//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ClipReply.h"
#include "Follow2PostDlgs.h"
#include "HelpDlgs.h"
#include "MsgWins.h"
#include "fileman.h"
#include "global.h"
#include "headman.h"
#include "mainmdi.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMergeForm *MergeForm;
//---------------------------------------------------------------------------
AnsiString __fastcall GetTemplateName(AnsiString &Caption, int mode)
{
   AnsiString tempname;
   TMergeForm *MF = new TMergeForm(AppMainForm);
   MF->mode = mode; MF->Caption = Caption;//modeArticle ? "Followup using..." : "Reply using...";
   TListBox *LB = MF->ListBox1; LB->Sorted = true;
   GetAppData(MF->Templates,UserTemplates);
   MF->FilterBox->Visible = false;
   MF->FilterBox->Checked = false;
   LB->ItemIndex = 0;
   CenterDialog(MF);
   MF->ShowModal();
   if (MF->ModalResult==mrOk)
   {
      switch (LB->ItemIndex)
      {
         case-1: break;
         case 0:
            tempname = mode==modeArticle ? DefaultArticle : DefaultMessage;
            break;
         default:
            tempname = LB->Items->Strings[LB->ItemIndex];
      }
   }
   delete MF;
   return tempname;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetMergeMessage(AnsiString &Caption, int mode)
{
   AnsiString tempname;
   TMergeForm *MF = new TMergeForm(AppMainForm);
   MF->mode = mode; MF->Caption = Caption;//modeArticle ? "Followup using..." : "Reply using...";
   TListBox *LB = MF->ListBox1; LB->Sorted = true;
   GetAppData(MF->Templates,UserTemplates);
   MF->FilterBox->Caption = mode==modeArticle ? "Followups":"Replies";
   if (mode==modeMessage)
   {
      MF->FilterBox->Left += 13;
      MF->FilterBox->Width = 55;
      MF->FilterBox->Checked = GetAppIni(TempRepliesChecked,"")=="1";
   }
   else
   if (mode==modeNymcnfg)
   {
      MF->FilterBox->Visible = false;
      MF->FilterBox->Checked = false;
      MF->Label3->Visible = true;
      //MF->Label3->Top = MF->Label3->Top+5;
      MF->ListBox1->Height = 148;
   }
   else
   if (mode==modeArticle)
      MF->FilterBox->Checked = GetAppIni(TempFollowupsChecked,"")=="1";

   LB->ItemIndex = 0;
   CenterDialog(MF);
   MF->ShowModal();
   if (MF->ModalResult==mrOk)
   {
      switch (LB->ItemIndex)
      {
         case-1: break;
         case 0:
            tempname = mode==modeArticle ? DefaultArticle : DefaultMessage;
            break;
         default:
            tempname = UserTemplates+PS+LB->Items->Strings[LB->ItemIndex];
      }
   }
   delete MF;
   return tempname;
}
//---------------------------------------------------------------------------
void __fastcall ClipboardReply(bool UseDialog)
{
   TMemo *m = new TMemo((void*)NULL);
   m->Visible = false;
   m->WordWrap = false;
   m->Parent = Application->MainForm;
   m->PasteFromClipboard();
   TStrings *OrgMessage = m->Lines;
   THeadMan *headers = new THeadMan(OrgMessage);

   if(!headers->Has("Reply-To: ",OrgMessage) && !headers->Has("From: "))
   {
      MsgBox(
         s("Clipboard does not appear to contain an email message!\n\n")+
         s("Chances are you neglected to include the message headers\n")+
         s("when you copied it to theclipboard."),
         "Reply Problem",
         MB_OK
      );
      TextWin = new TTextWin(Application->MainForm);
      TextWin->SetText("",OrgMessage);
      TextWin->Caption = "Clipboard Contents...";
      delete m;
      return;
   }

   AnsiString TemplateName=DefaultMessage;
   if (UseDialog && (TemplateName=GetMergeMessage("Clipboard Reply using...",modeMessage)).IsEmpty())
   {
      delete m;
      return;
   }

   ReplyToMessage(OrgMessage,TemplateName,"");
   delete m;
}
//---------------------------------------------------------------------------
void __fastcall ReplyToMessage(TStrings *Message, AnsiString &TemplateName,
  AnsiString &InReplyTo)
{
   AnsiString hdr,sub,mID,pststr=QteMarks,replyto,blank;
   TStringList *Template = new TStringList();
   GetAppData(Template,TemplateName);

   TStringList *lines = new TStringList();
   THeaderManager *TmpMan = new THeaderManager(Template);
   THeaderManager *MsgMan = new THeaderManager(Message);
   bool quote = TmpMan->GetDat("Quote-Original: ").LowerCase()!="no";
   TmpMan->Delete("Quote-Original: ");
   // get special header positions from template if there
   while (!(hdr=TmpMan->PopHeader()).IsEmpty())
   {
      if (hdr.Pos("References: ")==1 && hdr.Length()<13) hdr=MsgMan->Get4Reply("References: ");
      if (hdr.Pos("To: ")==1 && hdr.Length()<5) hdr=MsgMan->Get4Reply("To: ");
      if (hdr.Pos("Subject: ")==1 && hdr.Trim().Length()<10)
         hdr=MsgMan->Get4Reply("Subject: ");
      lines->Text = lines->Text + hdr;
   }
   hdr = "";
   // add special headers to end of headers if not handled above
   if (!lines->Text.Pos("To: ")) hdr=MsgMan->Get4Reply("To: ");
   if (!lines->Text.Pos("Subject: ") && !MsgMan->GetDat("Subject: ").IsEmpty())
      hdr += MsgMan->Get4Reply("Subject: ");
   if (!hdr.IsEmpty()) lines->Text = lines->Text + hdr;

   lines->Add("");
   if (quote) lines->Add("On "+MsgMan->GetDat("Date: ")+", you wrote:");

   int i,eoh = MsgMan->Eoh();
   // remove trailing nulls
   while (Message->Count)
   {
      if (Message->Strings[Message->Count-1].Trim().IsEmpty())
         Message->Delete(Message->Count-1);
      else break;
   }
   // add quoted message text to new message
   if (quote) for (i=eoh; i<Message->Count; i++) lines->Add(pststr+Message->Strings[i]);
   lines->Add("");
   // remove trailing nulls from template
   while (Template->Count && Template->Strings[Template->Count-1].IsEmpty())
      Template->Delete(Template->Count-1);
   // copy template sig to lines
   for (i=1; i<Template->Count; i++) lines->Add(Template->Strings[i]);
   // give it to the user
   MessageWin = new TMessageWin(lines,blank,blank,Application->MainForm);
   MessageWin->InReplyTo = InReplyTo;
   delete MsgMan;
   delete TmpMan;
   delete lines;
   delete Template;
}
//---------------------------------------------------------------------------
void __fastcall ClipboardFollowup(bool UseDialog)
{
   TMemo *m = new TMemo((void*)NULL);
   m->Visible = false;
   m->WordWrap = false;
   m->Parent = Application->MainForm;
   m->PasteFromClipboard();
   TStrings *OrgArticle = m->Lines;
   bool reply=false,follow=true;
   THeadMan *headers = new THeadMan(OrgArticle);
   {
      if (headers->GetDat("Followup-To: ").Trim().LowerCase()=="poster")
      {
         if (FollowupToPoster(AppMainForm,reply,follow))
         {
            if (reply && !follow)
            {
               ClipboardReply(UseDialog);
               delete headers;
               delete m;
               return;
            }
         }
         else return;
      }
   }
   if(!headers->Has("Newsgroups: ",OrgArticle) && !headers->Has("Followup-To: "))
   {
      MsgBox(
         s("Clipboard does not appear to contain a USENET article!\n\n")+
         s("Chances are you neglected to include the article headers\n")+
         s("when you copied it to the clipboard."),
         "Followup Problem",
         MB_OK
      );
      TextWin = new TTextWin(Application->MainForm);
      TextWin->SetText("",OrgArticle);
      TextWin->Caption = "Clipboard Contents...";
      delete headers;
      delete m;
      return;
   }

   AnsiString TemplateName=DefaultArticle;
   if (UseDialog && (TemplateName=GetMergeMessage("Clipboard Followup using...",modeArticle)).IsEmpty())
   {
      delete headers;
      delete m;
      return;
   }
   FollowupArticle(OrgArticle,TemplateName,reply);
   delete headers;
   delete m;
}
//---------------------------------------------------------------------------
void __fastcall FollowupArticle(TStrings *Article, AnsiString &TemplateName, bool reply2)
{
   AnsiString rep,adr,hdr,mID,pststr=QteMarks,blank;
   TStringList *Template = new TStringList();
   GetAppData(Template,TemplateName);

   TStringList *lines = new TStringList();
   THeaderManager *TmpMan = new THeaderManager(Template);
   THeaderManager *ArtMan = new THeaderManager(Article);
   // if followup-to in this message, drop any newsgroups header and
   // change followup-to to newsgroups and add back to article
   if (ArtMan->Has("Followup-To: "))
   {
      hdr = ArtMan->GetDat("Followup-To:");
      int idx = ArtMan->Delete("Newsgroups: ");
      if (idx<0) ArtMan->Eoh();
      Article->Insert(idx,"Newsgroups: "+hdr);
   }
   // get special header positions from template if there
   while (!(hdr=TmpMan->PopHeader()).IsEmpty())
   {
      if (hdr.Pos("References: ")==1)
         hdr=ArtMan->Get4Reply("References: ");
      else
      if (hdr.Pos("Newsgroups: ")==1 )
         hdr=ArtMan->Get4Reply("Newsgroups: ");
      else
      if (hdr.Pos("Subject: ")==1 && hdr.Trim().Length()<10)
         hdr=ArtMan->Get4Reply("Subject: ");
      lines->Text = lines->Text + hdr;
   }
   hdr = "";
   // add special headers to end of headers if not handled above
   if (!lines->Text.Pos("References: "))
      hdr =ArtMan->Get4Reply("References: ");
   if (!lines->Text.Pos("Newsgroups: "))
      hdr+=ArtMan->Get4Reply("Newsgroups: ");
   if (!lines->Text.Pos("Subject: "))
      hdr+=ArtMan->Get4Reply("Subject: ");
   if (!hdr.IsEmpty())
      lines->Text = lines->Text + hdr;

   lines->Add("");
   lines->Add("In article "+ArtMan->GetDat("Message-ID: "));
   lines->Add(ArtMan->GetDat("From: ")+" wrote: ");

   int i,eoh = ArtMan->Eoh();
   // remove trailing nulls
   while (Article->Count)
   {
      if (Article->Strings[Article->Count-1].Trim().IsEmpty())
         Article->Delete(Article->Count-1);
      else break;
   }
   // add quoted article text to new article
   for (i=eoh; i<Article->Count; i++) lines->Add(pststr+Article->Strings[i]);
   // remove trailing nulls from template
   while (Template->Count && Template->Strings[Template->Count-1].IsEmpty())
      Template->Delete(Template->Count-1);
   // copy template sig to lines
   for (i=1; i<Template->Count; i++) lines->Add(Template->Strings[i]);

   if (reply2) // user chooses to reply as well as followup
   {
      THeaderManager *LinMan = new THeaderManager(lines);
      adr = LinMan->GetDat("To: ");
      rep = ArtMan->GetDat("From: ");
      // make the authors address first in list
      if (!adr.IsEmpty()) rep += ",\r\n ";
      adr = rep + adr;
      // add the header back at present location
      int idx = LinMan->Delete("To: ");
      if (idx<0) idx = LinMan->Eoh();
      lines->Insert(idx,"To: "+adr);
   }

   // give it to the user
   MessageWin = new TMessageWin(lines,blank,blank,Application->MainForm);
   delete TmpMan;
   delete ArtMan;
   delete lines;
   delete Template;
}
//---------------------------------------------------------------------------
/*void __fastcall FollowupArticle(TStrings *Article, AnsiString &TemplateName)
{
   AnsiString hdr,mID,pststr=QteMarks,blank,ngrps,fgrps;
   TStringList *Template = new TStringList();
   GetAppData(Template,TemplateName);

   TStringList *lines = new TStringList();
   THeaderManager *TmpMan = new THeaderManager(Template);
   THeaderManager *ArtMan = new THeaderManager(Article);
   // if followup-to in this message, drop any newsgroups header and
   // change followup-to to newsgroups and add back to article
   if (ArtMan->Has("Followup-To: "))
   {
      hdr = ArtMan->GetDat("Followup-To:");
      int idx = ArtMan->Delete("Newsgroups: ");
      if (idx<0) for (int i=0; i<Article->Count; i++)
      {
         if (Article->Strings[i].Trim().IsEmpty())
         {
            Article->Insert(i,"Newsgroups: "+hdr);
            break;
         }
      }
   }
   // get special header positions from template if there
   while (!(hdr=TmpMan->PopHeader()).IsEmpty())
   {
      if (hdr.Pos("Newsgroups: ")==1) hdr=ArtMan->Get4Reply("Newsgroups: "); else
      if (hdr.Pos("References: ")==1) hdr=ArtMan->Get4Reply("References: "); else
      if (hdr.Pos("Subject: ")==1 && hdr.Trim().Length()<10)
          hdr=ArtMan->Get4Reply("Subject: ");
      lines->Text = lines->Text + hdr;
   }
   hdr = "";
   //if (!lines->Text.Pos("Followup-To: ")) hdr+=ArtMan->Get4Reply("Followup-To: ");
   if (!lines->Text.Pos("Newsgroups: ")) hdr+=ArtMan->Get4Reply("Newsgroups: ");
   if (!lines->Text.Pos("References: ")) hdr =ArtMan->Get4Reply("References: ");
   if (!lines->Text.Pos("Subject: ")) hdr+=ArtMan->Get4Reply("Subject: ");
   if (!hdr.IsEmpty()) lines->Text = lines->Text + hdr;

   lines->Add("");
   lines->Add("In article "+ArtMan->GetDat("Message-ID: "));
   lines->Add(ArtMan->GetDat("From: ")+" wrote: ");

   int i,eoh = ArtMan->Eoh();
   // remove trailing nulls
   while (Article->Count)
   {
      if (Article->Strings[Article->Count-1].Trim().IsEmpty())
         Article->Delete(Article->Count-1);
      else break;
   }
   // add quoted article text to new article
   for (i=eoh; i<Article->Count; i++) lines->Add(pststr+Article->Strings[i]);
   // remove trailing nulls from template
   while (Template->Count && Template->Strings[Template->Count-1].IsEmpty())
      Template->Delete(Template->Count-1);
   // copy template sig to lines
   for (i=1; i<Template->Count; i++) lines->Add(Template->Strings[i]);

   // give it to the user
   MessageWin = new TMessageWin(lines,blank,blank,Application->MainForm);
   //delete LinMan;
   delete ArtMan;
   delete TmpMan;
   delete lines;
   delete Template;
}*/
//---------------------------------------------------------------------------
__fastcall TMergeForm::TMergeForm(TComponent* Owner)
  : TForm(Owner)
{
   Templates = new TStringList();
   Templates->Sorted = true;
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && ListBox1->ItemIndex<0)
   {
      MsgBoxHwnd(Handle,
         AnsiString("You must select a template!"),
         "Nothing Selected",
         MB_OK);
      CanClose = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::FormDestroy(TObject *Sender)
{
   delete Templates;
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::ListBox1DblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::ListBox1DrawItem(TWinControl *Control, int Index,
  TRect &Rect, TOwnerDrawState State)
{
   TRect r(Rect);
   ListBox1->Canvas->FillRect(r);
   ListBox1->Canvas->TextRect(r,r.Left+4, r.Top+1, ListBox1->Items->Strings[Index]);
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::FilterTemplates(bool filter)
{
   ListBox1->Clear();
   AppProcessMessages(); Sleep(100);
   AnsiString type = mode==modeArticle ? "followup":"reply";
   AnsiString newmsg = type=="reply" ? "<new nessage>\n":"<new article>\n";

   if (!filter) ListBox1->Items->Text = newmsg+Templates->Text;
   else
   {
      AnsiString temps;
      for (int i=0; i<Templates->Count; i++)
         if (Templates->Strings[i].LowerCase().Pos(type))
            temps += Templates->Strings[i]+"\r\n";
      ListBox1->Items->Text = newmsg+temps;
   }

   if (mode==modeArticle)
      PutAppIni(TempFollowupsChecked,FilterBox->Checked?"1":"0");
   else
      PutAppIni(TempRepliesChecked,FilterBox->Checked?"1":"0");
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::FormShow(TObject *Sender)
{
   FilterTemplates(FilterBox->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::FilterBoxClick(TObject *Sender)
{
   FilterTemplates(FilterBox->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::HelpBtnClick(TObject *Sender)
{
   if (mode==modeArticle)
      OpenHelp("ClipboardFollowup","Clipboard Followup Dialog","",AppMainForm); else
   if (mode==modeMessage)
      OpenHelp("ClipboardReply","Clipboard Reply Dialog","",AppMainForm); else
   if (mode==modeNymcnfg)
      OpenHelp("TemplatesNyms","The Nym-Config Template","",AppMainForm);
}
//---------------------------------------------------------------------------
