//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NymRptsDlgs.h"
#include "FileMan.h"
#include "NymMail.h"
#include "RptWin.h"
#include "MsgBoxDlgs.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNymRptsDlg *NymRptsDlg;
//---------------------------------------------------------------------------
void __fastcall RunNymReports(TForm *Owner)
{
   NymRptsDlg = new TNymRptsDlg(Owner);
   NymRptsDlg->ShowModal();
   delete NymRptsDlg;
}
//---------------------------------------------------------------------------
__fastcall TNymRptsDlg::TNymRptsDlg(TComponent* Owner)
	: TForm(Owner)
{
   GetAppData(NymList->Items,NymProfilesKey);
   CenterDialog(this,Owner);
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::PutReportOnDeskTop(TStrings *report, AnsiString caption)
{
   ReportWin = new TReportWin(report,caption,AppMainForm);
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::SelectAll(bool select)
{
   for (int i=0; i<NymList->Items->Count; i++)
      NymList->Selected[i] = select;
   OkBtn->Enabled = NymList->SelCount>0;
   ActiveControl = Panel1;
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::NymListDblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::SelectAllBtnClick(TObject *Sender)
{
   SelectAll(true);
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      if (!NymList->SelCount)
      {
         ErrorBox(this,"No nyms selected for report!",MB_OK);
         CanClose = false;
         return;
      }
      AnsiString cap = Caption; Caption = "Working..."; Sleep(100);
      if (ProfileBtn->Checked) GenProfileReport(); else
      if (EncryptBtn->Checked) GenEncryptReport(); else
      if (ChainsBtn->Checked) GenChainsReport(); else
      if (ExportBtn->Checked) GenExportReport();
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::GenChainsReport()
{
   AnsiString nym,nymline,line;
   TStringList *list = new TStringList();
   TStringList *profile = new TStringList();
   for (int n=0; n<NymList->Items->Count; n++)
   {
      if (!NymList->Selected[n]) continue;
      bool inrepblk = false;
      nym = NymList->Items->Strings[n];
      nymline = nym;
      GetAppData(profile,NymProfilesKey+PS+nym);
      for (int i=0; i<profile->Count; i++)
      {
         line = profile->Strings[i].Trim();
         if (!inrepblk && line.Pos("Reply-Block:")!=1) continue;
         if (line.Pos("-----BEGIN PGP PUBLIC KEY BLOCK-----")==1) break;
         if (line.Pos("Reply-Block:")==1) nymline += "\r\n"+line; else
         if (line.Pos(":")==0) nymline += "  ->  "+line; else
         if (line=="") nymline += "\r\n";
         inrepblk = true;
      }
      list->Add(nymline+"\r\n");
   }
   PutReportOnDeskTop(list,"Nym Remailer Chains");
   delete profile;
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::GenEncryptReport()
{
   AnsiString nym,nymline,line;
   TStringList *list = new TStringList();
   TStringList *profile = new TStringList();
   for (int n=0; n<NymList->Items->Count; n++)
   {
      if (!NymList->Selected[n]) continue;
      bool inrepblk = false;
      nym = NymList->Items->Strings[n];
      nymline = nym;
      GetAppData(profile,NymProfilesKey+PS+nym);
      for (int i=0; i<profile->Count; i++)
      {
         line = profile->Strings[i].Trim();
         if (!inrepblk && line.Pos("Reply-Block:")!=1) continue;
         if (line.Pos("-----BEGIN PGP PUBLIC KEY BLOCK-----")==1) break;
         if (line.Pos("Reply-Block:")==1) nymline += "\r\n"+line; else
         if (line.Pos("Encrypt-Key:")==1) nymline += "  ->  "+line.SubString(14,128); else
         if (line=="") nymline += "\r\n";
         inrepblk = true;
      }
      list->Add(nymline+"\r\n");
   }
   PutReportOnDeskTop(list,"Nym Encrypt-Keys");
   delete profile;
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::GenExportReport()
{
   AnsiString nym,nymline,line;
   TStringList *list = new TStringList();
   TStringList *profile = new TStringList();
   for (int n=0; n<NymList->Items->Count; n++)
   {
      if (!NymList->Selected[n]) continue;
      bool inkeys = false;
      nym = NymList->Items->Strings[n];
      if (list->Count) list->Add("");
      list->Add(nym);
      GetAppData(profile,NymProfilesKey+PS+nym);
      for (int i=0; i<profile->Count; i++)
      {
         line = profile->Strings[i].Trim();
         if (line.Pos("PgpKey: ")==1) list->Add(line+"\r\n");
         if (line.Pos("-----BEGIN PGP ")==1) inkeys = true;
         if (!inkeys) continue;

         list->Add(line);
         if (line.Pos("-----END PGP ")==1) list->Add("");

      }
   }
   PutReportOnDeskTop(list,"Nym PGP Keys Export");
   delete profile;
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::GenProfileReport()
{
   AnsiString nym,nymline,item,line;
   TStringList *list = new TStringList();
   TStringList *profile = new TStringList();
   for (int n=0; n<NymList->Items->Count; n++)
   {
      if (!NymList->Selected[n]) continue;
      nym = NymList->Items->Strings[n];
      //list->Add(nym+"\r\n");
      GetAppData(profile,NymProfilesKey+PS+nym);
      for (int i=0; i<profile->Count; i++)
      {
         line = profile->Strings[i];
         if (line.Pos("-----BEGIN PGP ")==1) break;
         if (line.Pos("Nym: ")==1) line = line.SubString(6,64);
         if (line.Trim().Pos("Reply-Block:")==1) list->Add("");
         list->Add(line);
      }
      list->Add("");
   }
   PutReportOnDeskTop(list,"Nym Profiles");
   delete profile;
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall TNymRptsDlg::NymListClick(TObject *Sender)
{
   OkBtn->Enabled = NymList->SelCount>0;	
}
//---------------------------------------------------------------------------
