//---------------------------------------------------------------------------
#ifndef PgpSdk1H
#define PgpSdk1H

#include <pgpKeys.h>
#include <pgpErrors.h>
#include <pgpUtilities.h>
#include <pgpSDKPrefs.h>
#include <pgpFeatures.h>
#include <pgpOptionList.h>
#include <pgpMemoryMgr.h>
#include "global.h"
//---------------------------------------------------------------------------
bool __fastcall HasSdk();

class TPGPsdk
{
   PGPError __fastcall PGPsdkInit();
   PGPError __fastcall PGPsdkCleanup();
   PGPError __fastcall PGPNewContext(PGPUInt32 clientAPIVersion, PGPContextRef *newContext);
   PGPError __fastcall PGPsdkLoadDefaultPrefs(PGPContextRef context);
   PGPError __fastcall PGPsdkPrefGetFileSpec(PGPContextRef context, PGPsdkPrefSelector selector, PGPFileSpecRef * outRef);
   PGPError __fastcall PGPGetFullPathFromFileSpec(PGPFileSpecRef fileRef, char **fullPathPtr);
   PGPError __fastcall PGPGetErrorString(PGPError theError, PGPSize bufferSize, char *theString);
   PGPError __fastcall PGPGetSDKVersion(PGPUInt32 *version);
   PGPError __fastcall PGPFreeFileSpec(PGPFileSpecRef fileRef);
   PGPError __fastcall PGPExportKeySet(PGPKeySetRef keys, PGPOptionListRef firstOpt,
      PGPOptionListRef secondOpt,PGPOptionListRef thirdOpt, PGPOptionListRef forthOpt,
      PGPOptionListRef fifthOpt);
   PGPError __fastcall PGPFreeKeySet(PGPKeySetRef keys);
   PGPError __fastcall PGPFreeData(void *allocation);
   PGPError __fastcall PGPOpenDefaultKeyRings(PGPContextRef context, PGPKeyRingOpenFlags openFlags,
      PGPKeySetRef *keySet);
   PGPError __fastcall PGPNewKeyDisabledFilter(PGPContextRef context, PGPBoolean disabled,
      PGPFilterRef *outFilter);
   PGPError __fastcall PGPNewKeyRevokedFilter(PGPContextRef context, PGPBoolean revoked,
      PGPFilterRef *outFilter);
   PGPError __fastcall PGPFilterKeySet(PGPKeySetRef origSet, PGPFilterRef filter,
      PGPKeySetRef *resultSet);
   PGPError __fastcall PGPOrderKeySet(PGPKeySetRef src, PGPKeyOrdering order,
      PGPKeyListRef *outRef );
   PGPError __fastcall PGPNewKeyIter(PGPKeyListRef keys, PGPKeyIterRef *outRef);
   PGPError __fastcall PGPGetKeyIDFromKey(PGPKeyRef key, PGPKeyID *id);
   PGPError __fastcall PGPGetKeyIDFromString(const char *string, PGPKeyID *id);
   PGPError __fastcall PGPGetKeyIDString(PGPKeyID const *ref, PGPKeyIDStringType type,
      char outString[kPGPMaxKeyIDStringSize]);
   PGPError __fastcall PGPKeyIterNext(PGPKeyIterRef iter, PGPKeyRef *outRef);
   PGPError __fastcall PGPFreeKeyIter(PGPKeyIterRef iter);
   PGPError __fastcall PGPFreeKeyList(PGPKeyListRef keys);
   PGPError __fastcall PGPFreeFilter(PGPFilterRef filter);
   PGPOptionListRef __fastcall PGPOExportFormat(PGPContextRef context, PGPExportFormat exportFormat);
   PGPOptionListRef __fastcall PGPOExportPrivateKeys(PGPContextRef context, PGPBoolean exportKeys);
   PGPOptionListRef __fastcall PGPOVersionString(PGPContextRef context, const char *version);
   PGPOptionListRef __fastcall PGPOLastOption(PGPContextRef context);
   PGPOptionListRef __fastcall PGPOAllocatedOutputBuffer(PGPContextRef context, void **buffer,
      PGPSize maximumBufferSize, PGPSize *actualBufferSize);
   void __fastcall ShowPGPError(PGPError err, AnsiString errmsg);
   bool __fastcall IsPgpError(PGPError err, char *errmsg);
public:
   TForm *owner;
   PGPError err;
   HINSTANCE hSdkLib;
   PGPContextRef context;
   PGPUInt32 apiversion,sdkversion;
   char *pubringpkr,*secringskr;
   __fastcall TPGPsdk(TForm *Owner, HINSTANCE &hPgpSdk);
   __fastcall~TPGPsdk();
   bool __fastcall ExportDefaultKeys(TStrings *exports);
   bool __fastcall ExportDefaultKeysFast(TStrings *exports);
   PGPError __fastcall ExportKeySet(PGPKeySetRef keys, PGPExportFormat &ExportFormat,
      bool IncludePrivates, TStrings *exports);
   PGPError __fastcall GetDisableKeyIds(PGPKeySetRef keyset, TStrings *keyids);
   PGPError __fastcall GetRevokedKeyIds(PGPKeySetRef keyset, TStrings *keyids);
   bool __fastcall CheckPGP6NeedsUpdate(TControl *ForHourGlass);
   bool __fastcall UpdateQSKeyrings(TControl *ForHourGlass);
   bool __fastcall UpdateQSKeyringsFast(TControl *ForHourGlass);
   bool __fastcall UpdateQSKeyringsSlow(TControl *ForHourGlass);
};

typedef PGPError (*PGPSDKINIT)(void);
typedef PGPError (*PGPSDKCLEANUP)(void);
typedef PGPError (*PGPNEWCONTEXT)(PGPUInt32, PGPContextRef*);
typedef PGPError (*PGPSDKLOADDEFAULTPREFS)(PGPContextRef);
typedef PGPError (*PGPSDKPREFGETFILESPEC)(PGPContextRef, PGPsdkPrefSelector, PGPFileSpecRef*);
typedef PGPError (*PGPGETFULLPATHFROMFILESPEC)(PGPFileSpecRef, char**);
typedef PGPError (*PGPGETERRORSTRING)(PGPError, PGPSize, char*);
typedef PGPError (*PGPGETSDKVERSION)(PGPUInt32*);
typedef PGPError (*PGPFREEFILESPEC)(PGPFileSpecRef fileRef);
typedef PGPError (*PGPEXPORTKEYSET)(PGPKeySetRef, PGPOptionListRef, PGPOptionListRef,
      PGPOptionListRef, PGPOptionListRef, PGPOptionListRef);
typedef PGPError (*PGPFREEKEYSET)(PGPKeySetRef);
typedef PGPError (*PGPFREEDATA)(void *allocation);
typedef PGPError (*PGPOPENDEFAULTKEYRINGS)(PGPContextRef, PGPKeyRingOpenFlags, PGPKeySetRef*);
typedef PGPError (*PGPNEWKEYDISABLEDFILTER)(PGPContextRef, PGPBoolean, PGPFilterRef*);
typedef PGPError (*PGPNEWKEYREVOKEDFILTER)(PGPContextRef, PGPBoolean, PGPFilterRef*);
typedef PGPError (*PGPFILTERKEYSET)(PGPKeySetRef, PGPFilterRef, PGPKeySetRef*);
typedef PGPError (*PGPORDERKEYSET)(PGPKeySetRef, PGPKeyOrdering, PGPKeyListRef*);
typedef PGPError (*PGPNEWKEYITER)(PGPKeyListRef, PGPKeyIterRef*);
typedef PGPError (*PGPGETKEYIDFROMKEY)(PGPKeyRef, PGPKeyID*);
typedef PGPError (*PGPGETKEYIDFROMSTRING)(const char*, PGPKeyID*);
typedef PGPError (*PGPGETKEYIDSTRING)(PGPKeyID const*, PGPKeyIDStringType,
   char[kPGPMaxKeyIDStringSize]);
typedef PGPError (*PGPKEYITERNEXT)(PGPKeyIterRef, PGPKeyRef*);
typedef PGPError (*PGPFREEKEYITER)(PGPKeyIterRef);
typedef PGPError (*PGPFREEKEYLIST)(PGPKeyListRef);
typedef PGPError (*PGPFREEFILTER)(PGPFilterRef);
typedef PGPOptionListRef (*PGPOEXPORTFORMAT)(PGPContextRef, PGPExportFormat);
typedef PGPOptionListRef (*PGPOEXPORTPRIVATEKEYS)(PGPContextRef, PGPBoolean);
typedef PGPOptionListRef (*PGPOVERSIONSTRING)(PGPContextRef, const char*);
typedef PGPOptionListRef (*PGPOLASTOPTION)(PGPContextRef);
typedef PGPOptionListRef (*PGPOALLOCATEDOUTPUTBUFFER)(PGPContextRef, void**, PGPSize,
   PGPSize*);

//---------------------------------------------------------------------------
extern TPGPsdk *PGPsdk;
extern HINSTANCE hPgpSdk;
//---------------------------------------------------------------------------
#endif
